# Stacks

Authors: Darren Yao, Michael Cao

### Prerequisites

A data structures that only allows insertion and deletion at one end.

Resources | |||
---|---|---|---|

CPH | brief description of operations | ||

CSA | Bracket Matching Application |

## Stacks

A stack is a **Last In First Out** (LIFO) data structure that supports three operations, all in $\mathcal{O}(1)$ time. Think of it like a real-world stack of papers.

C++

### C++

`push`

: adds an element to the top of the stack`pop`

: removes an element from the top of the stack`top`

: retrieves the element at the top without removing it

stack<int> s;s.push(1); // [1]s.push(13); // [1, 13]s.push(7); // [1, 13, 7]cout << s.top() << endl; // 7s.pop(); // [1, 13]cout << s.size() << endl; // 2

Java

### Java

`push`

: adds an element to the top of the stack`pop`

: removes an element from the top of the stack`peek`

: retrieves the element at the top without removing it

Stack<Integer> s = new Stack<Integer>();s.push(1); // [1]s.push(13); // [1, 13]s.push(7); // [1, 13, 7]System.out.println(s.peek()); // 7s.pop(); // [1, 13]System.out.println(s.size()); // 2

## Application: Nearest Smaller Element

Focus Problem – read through this problem before continuing!

Consider the following problem:

Given an array, $a$, of $N$ ($1 \le N \le 10^5$) integers, for every index $i$, find the rightmost index $j$ such that $j < i$ and $a_i > a_j$.

Resources | |||
---|---|---|---|

CPH | |||

CSA | similar application w/ animation |

To solve this, let's store a stack of pairs of $value, index$ and iterate over the array from left to right. For some index $i$, we will compute $\texttt{ans}[i]$, the rightmost index for $i$, as follows:

- Keep popping the top element off the stack as long as $value \ge a_i$. This is because we know that the pair containing $value$ will never be the solution to any index $j > i$, since $a_i$ is less than or equal to than $value$ and has an index further to the right.
- If $value < a_i$, set $\texttt{ans}[i]$ to $index$, because a stack stores the most recently added values first (or in this case, the rightmost ones), $index$ will contain the rightmost value which is less than $a_i$. Then, add ($a_i, i$) to the stack.

The stack we used is called a **monotonic stack** because we keep popping off the top element of the stack which maintains it's monotonicity (the same property needed for algorithms like binary search) because the elements in the stack are increasing.

### Implementation

C++

#include <bits/stdc++.h>using namespace std;int N;int main() {ios_base::sync_with_stdio(0);cin.tie(0);

Java

/*** author: Kai Wang*/import java.io.*; import java.util.*;public class NearestSmallestVals {/*** We keep a stack of pairs (ind, value)* Traverse the array from left to right, use ans to store answers

## Problems

Status | Source | Problem Name | Difficulty | Tags | Solution | URL |
---|---|---|---|---|---|---|

LC | Normal | |||||

Gold | Normal | External Sol | ||||

Gold | Normal | External Sol | ||||

CSES | Normal | |||||

CEOI | Normal | Check CF | ||||

IOI | Very Hard | |||||

InfoArena | Very Hard | View Solution | ||||

CSES | Insane | View Solution | ||||

Croatian OI | Insane | External Sol |

### Module Progress:

### Join the USACO Forum!

Stuck on a problem, or don't understand a module? Join the USACO Forum and get help from other competitive programmers!

## Give Us Feedback on Stacks!

Leave suggestions for us by making a post on the USACO Forum! Ex: Unclear sections, mislabeled problems, etc.